﻿using System.Collections.Generic;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;
using System.Drawing;

namespace ConsoleApplication65
{
    class Program
    {
        static void Main(string[] args)
        {
            //Open the template Word document.
            WordDocument document = new WordDocument(@"..\..\Data\Template.docx");
           
            //Uses the mail merge events handler to remove field labels.
            document.MailMerge.MergeField += new MergeFieldEventHandler(MergeField_Event);
            //Specifies the field names and field values
            string[] fieldNames = { "OrderNo","OrderDate","ShippedDate","RequiredDate"};
            string[] fieldValues = { "123",string.Empty,"01-01-2017","01-01-2017"};

            //Mail merge event is common to all methods Execute(),ExecuteGroup(),ExecuteNestedGroup().
            document.MailMerge.Execute(fieldNames, fieldValues);
            document.Save(@"..\..\Data\Result.docx", FormatType.Docx);
            document.Close();


            System.Diagnostics.Process.Start(@"..\..\Data\Result.docx");
        }
        /// <summary>
        /// Mail merge event.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        private static void MergeField_Event(object sender, MergeFieldEventArgs args)
        {
            string fieldValue = args.FieldValue.ToString();
            //When field value is Null or empty, then remove the field owner paragraph.
            if (string.IsNullOrEmpty(fieldValue))
            {
                //Get the merge field owner paragraph and remove it from its owner text body.
                WParagraph ownerParagraph = args.CurrentMergeField.OwnerParagraph;
                WTextBody ownerTextBody = ownerParagraph.OwnerTextBody;
                ownerTextBody.ChildEntities.Remove(ownerParagraph);
            }
        }
    }

}